/* DO NOT EDIT! GENERATED AUTOMATICALLY! */

#line 1 "fd-styled-ostream.oo.c"
/* Output stream with no-op styling, referring to a file descriptor.
   Copyright (C) 2006, 2019 Free Software Foundation, Inc.
   Written by Bruno Haible <bruno@clisp.org>, 2019.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

#include <config.h>

/* Specification.  */
#include "fd-styled-ostream.h"

#include "fd-ostream.h"

#include "xalloc.h"


#line 32 "fd-styled-ostream.c"
#if !IS_CPLUSPLUS
#define fd_styled_ostream_representation any_ostream_representation
#endif
#include "fd_styled_ostream.priv.h"

const typeinfo_t fd_styled_ostream_typeinfo = { "fd_styled_ostream" };

static const typeinfo_t * const fd_styled_ostream_superclasses[] =
  { fd_styled_ostream_SUPERCLASSES };

#define super styled_ostream_vtable

#line 34 "fd-styled-ostream.oo.c"

/* Implementation of ostream_t methods.  */

static void
fd_styled_ostream__write_mem (fd_styled_ostream_t stream,
                              const void *data, size_t len)
{
  fd_ostream_write_mem (stream->destination, data, len);
}

static void
fd_styled_ostream__flush (fd_styled_ostream_t stream, ostream_flush_scope_t scope)
{
  fd_ostream_flush (stream->destination, scope);
}

static void
fd_styled_ostream__free (fd_styled_ostream_t stream)
{
  fd_ostream_free (stream->destination);
  free (stream);
}

/* Implementation of styled_ostream_t methods.  */

static void
fd_styled_ostream__begin_use_class (fd_styled_ostream_t stream,
                                    const char *classname)
{
}

static void
fd_styled_ostream__end_use_class (fd_styled_ostream_t stream,
                                  const char *classname)
{
}

static void
fd_styled_ostream__flush_to_current_style (fd_styled_ostream_t stream)
{
  fd_ostream_flush (stream->destination, FLUSH_THIS_STREAM);
}

/* Constructor.  */

fd_styled_ostream_t
fd_styled_ostream_create (int fd, const char *filename)
{
  fd_styled_ostream_t stream =
    XMALLOC (struct fd_styled_ostream_representation);

  stream->base.base.vtable = &fd_styled_ostream_vtable;
  stream->destination = fd_ostream_create (fd, filename, true);

  return stream;
}

#line 103 "fd-styled-ostream.c"

const struct fd_styled_ostream_implementation fd_styled_ostream_vtable =
{
  fd_styled_ostream_superclasses,
  sizeof (fd_styled_ostream_superclasses) / sizeof (fd_styled_ostream_superclasses[0]),
  sizeof (struct fd_styled_ostream_representation),
  fd_styled_ostream__write_mem,
  fd_styled_ostream__flush,
  fd_styled_ostream__free,
  fd_styled_ostream__begin_use_class,
  fd_styled_ostream__end_use_class,
  fd_styled_ostream__flush_to_current_style,
};

#if !HAVE_INLINE

/* Define the functions that invoke the methods.  */

void
fd_styled_ostream_write_mem (fd_styled_ostream_t first_arg, const void *data, size_t len)
{
  const struct fd_styled_ostream_implementation *vtable =
    ((struct fd_styled_ostream_representation_header *) (struct fd_styled_ostream_representation *) first_arg)->vtable;
  vtable->write_mem (first_arg,data,len);
}

void
fd_styled_ostream_flush (fd_styled_ostream_t first_arg, ostream_flush_scope_t scope)
{
  const struct fd_styled_ostream_implementation *vtable =
    ((struct fd_styled_ostream_representation_header *) (struct fd_styled_ostream_representation *) first_arg)->vtable;
  vtable->flush (first_arg,scope);
}

void
fd_styled_ostream_free (fd_styled_ostream_t first_arg)
{
  const struct fd_styled_ostream_implementation *vtable =
    ((struct fd_styled_ostream_representation_header *) (struct fd_styled_ostream_representation *) first_arg)->vtable;
  vtable->free (first_arg);
}

void
fd_styled_ostream_begin_use_class (fd_styled_ostream_t first_arg, const char *classname)
{
  const struct fd_styled_ostream_implementation *vtable =
    ((struct fd_styled_ostream_representation_header *) (struct fd_styled_ostream_representation *) first_arg)->vtable;
  vtable->begin_use_class (first_arg,classname);
}

void
fd_styled_ostream_end_use_class (fd_styled_ostream_t first_arg, const char *classname)
{
  const struct fd_styled_ostream_implementation *vtable =
    ((struct fd_styled_ostream_representation_header *) (struct fd_styled_ostream_representation *) first_arg)->vtable;
  vtable->end_use_class (first_arg,classname);
}

void
fd_styled_ostream_flush_to_current_style (fd_styled_ostream_t first_arg)
{
  const struct fd_styled_ostream_implementation *vtable =
    ((struct fd_styled_ostream_representation_header *) (struct fd_styled_ostream_representation *) first_arg)->vtable;
  vtable->flush_to_current_style (first_arg);
}

#endif
